(text "{% extends \"root.html\" %} {% block head %}")
(title
    (text "Manage profile - {{ config.name }}"))

(text "{% endblock %} {% block body %} {{ macros::nav() }}")
(main
    ("class" "flex flex-col gap-2")
    (div
        ("class" "card-nest w-full")
        (div
            ("class" "card small flex items-center gap-2")
            (text "{{ icon \"shield\" }}")
            (span
                (text "{{ text \"mod_panel:label.manage_profile\" }}")))
        (div
            ("class" "card lowered")
            (div
                ("class" "flex flex-col gap-2")
                ("id" "mod_options")
                (div
                    ("class" "card w-full flex flex-wrap gap-2")
                    ("ui_ident" "actions")
                    (a
                        ("href" "/settings?username={{ profile.username }}")
                        ("class" "button lowered")
                        (text "{{ icon \"settings\" }}")
                        (span
                            (text "View settings")))
                    (a
                        ("href" "/mod_panel/profile/{{ profile.id }}/warnings")
                        ("class" "button lowered")
                        (text "{{ icon \"shield-alert\" }}")
                        (span
                            (text "View warnings")))
                    (a
                        ("href" "/notifs?id={{ profile.id }}")
                        ("class" "button lowered")
                        (text "{{ icon \"bell\" }}")
                        (span
                            (text "Notifications"))
                        (span
                            ("class" "notification")
                            (text "{{ profile.notification_count }}")))
                    (a
                        ("href" "/requests?id={{ profile.id }}")
                        ("class" "button lowered")
                        (text "{{ icon \"inbox\" }}")
                        (span
                            (text "Requests"))
                        (span
                            ("class" "notification")
                            (text "{{ profile.request_count }}")))
                    (a
                        ("href" "/services?id={{ profile.id }}")
                        ("class" "button lowered")
                        (icon (text "globe"))
                        (span
                            (text "Sites")))
                    (a
                        ("href" "/domains?id={{ profile.id }}")
                        ("class" "button lowered")
                        (icon (text "globe"))
                        (span
                            (text "Domains")))
                    (button
                        ("class" "red lowered")
                        ("onclick" "delete_account(event)")
                        (text "{{ icon \"trash\" }}")
                        (span
                            (text "{{ text \"settings:label.delete_account\" }}")))
                    (text "{% if profile.permissions != 131073 -%}")
                    (button
                        ("class" "red lowered")
                        ("onclick" "update_user_role(131073)")
                        (text "Ban"))
                    (text "{% else %}")
                    (button
                        ("class" "lowered")
                        ("onclick" "update_user_role(1)")
                        (text "Unban"))
                    (text "{%- endif %}")))
            (script
                (text "setTimeout(async () => {
                    const ui = await ns(\"ui\");
                    const element = document.getElementById(\"mod_options\");

                    globalThis.profile_request = async (do_confirm, path, body) => {
                        if (do_confirm) {
                            if (
                                !(await trigger(\"atto::confirm\", [
                                    \"Are you sure you would like to do this?\",
                                ]))
                            ) {
                                return;
                            }
                        }

                        fetch(`/api/v1/auth/user/{{ profile.id }}/${path}`, {
                            method: \"POST\",
                            headers: {
                                \"Content-Type\": \"application/json\",
                            },
                            body: JSON.stringify(body),
                        })
                            .then((res) => res.json())
                            .then((res) => {
                                trigger(\"atto::toast\", [
                                    res.ok ? \"success\" : \"error\",
                                    res.message,
                                ]);
                            });
                    }

                    globalThis.delete_account = async (e) => {
                        e.preventDefault();

                        if (
                            !(await trigger(\"atto::confirm\", [
                                \"Are you sure you would like to do this?\",
                            ]))
                        ) {
                            return;
                        }

                        fetch(\"/api/v1/auth/user/{{ profile.id }}\", {
                            method: \"DELETE\",
                            headers: {
                                \"Content-Type\": \"application/json\",
                            },
                            body: JSON.stringify({
                                password: \"\",
                            }),
                        })
                            .then((res) => res.json())
                            .then((res) => {
                                trigger(\"atto::toast\", [
                                    res.ok ? \"success\" : \"error\",
                                    res.message,
                                ]);
                            });
                    };

                    globalThis.update_user_role = async (new_role) => {
                        if (
                            !(await trigger(\"atto::confirm\", [
                                \"Are you sure you would like to do this?\",
                            ]))
                        ) {
                            return;
                        }

                        fetch(`/api/v1/auth/user/{{ profile.id }}/role`, {
                            method: \"POST\",
                            headers: {
                                \"Content-Type\": \"application/json\",
                            },
                            body: JSON.stringify({
                                role: Number.parseInt(new_role),
                            }),
                        })
                            .then((res) => res.json())
                            .then((res) => {
                                trigger(\"atto::toast\", [
                                    res.ok ? \"success\" : \"error\",
                                    res.message,
                                ]);
                            });
                    };

                    globalThis.update_user_secondary_role = async (new_role) => {
                        if (
                            !(await trigger(\"atto::confirm\", [
                                \"Are you sure you would like to do this?\",
                            ]))
                        ) {
                            return;
                        }

                        fetch(`/api/v1/auth/user/{{ profile.id }}/role/2`, {
                            method: \"POST\",
                            headers: {
                                \"Content-Type\": \"application/json\",
                            },
                            body: JSON.stringify({
                                role: Number.parseInt(new_role),
                            }),
                        })
                            .then((res) => res.json())
                            .then((res) => {
                                trigger(\"atto::toast\", [
                                    res.ok ? \"success\" : \"error\",
                                    res.message,
                                ]);
                            });
                    };

                    ui.refresh_container(element, [\"actions\"]);

                    setTimeout(() => {
                        ui.refresh_container(element, [\"actions\"]);

                        ui.generate_settings_ui(
                            element,
                            [
                                [
                                    [\"is_verified\", \"Is verified\"],
                                    \"{{ profile.is_verified }}\",
                                    \"checkbox\",
                                ],
                                [
                                    [\"awaiting_purchase\", \"Awaiting purchase\"],
                                    \"{{ profile.awaiting_purchase }}\",
                                    \"checkbox\",
                                ],
                                [
                                    [\"role\", \"Permission level\"],
                                    \"{{ profile.permissions }}\",
                                    \"input\",
                                ],
                                [
                                    [\"secondary_role\", \"Secondary permission level\"],
                                    \"{{ profile.secondary_permissions }}\",
                                    \"input\",
                                ],
                            ],
                            null,
                            {
                                is_verified: (value) => {
                                    profile_request(false, \"verified\", {
                                        is_verified: value,
                                    });
                                },
                                awaiting_purchase: (value) => {
                                    profile_request(false, \"awaiting_purchase\", {
                                        awaiting_purchase: value,
                                    });
                                },
                                role: (new_role) => {
                                    return update_user_role(new_role);
                                },
                                secondary_role: (new_role) => {
                                    return update_user_secondary_role(new_role);
                                },
                            },
                        );
                    }, 100);
                }, 150);"))))
    (div
        ("class" "card-nest w-full")
        (div
            ("class" "card small flex items-center justify-between gap-2")
            (div
                ("class" "flex items-center gap-2")
                (text "{{ icon \"users-round\" }}")
                (span
                    (text "{{ text \"mod_panel:label.associations\" }}"))))
        (div
            ("class" "card lowered flex flex-wrap gap-2")
            (text "{% for user in associations -%}")
            (text "{{ components::user_plate(user=user, show_menu=false) }}")
            (text "{%- endfor %}")))
    (text "{% if invite -%}")
    (div
        ("class" "card-nest w-full")
        (div
            ("class" "card small flex items-center justify-between gap-2")
            (div
                ("class" "flex items-center gap-2")
                (text "{{ icon \"ticket\" }}")
                (span
                    (text "{{ text \"mod_panel:label.invited_by\" }}"))))
        (div
            ("class" "card lowered flex flex-wrap gap-2")
            (text "{{ components::user_plate(user=invite[0], show_menu=false) }}")))
    (text "{%- endif %}")
    (div
        ("class" "card-nest w-full")
        (div
            ("class" "card small flex items-center justify-between gap-2")
            (div
                ("class" "flex items-center gap-2")
                (icon (text "scale"))
                (span
                    (str (text "mod_panel:label.ban_reason")))))
        (form
            ("class" "card flex flex-col gap-2")
            ("onsubmit" "event.preventDefault(); profile_request(false, 'ban_reason', { reason: event.target.reason.value || '' })")
            (div
                ("class" "flex flex-col gap-1")
                (label
                    ("for" "title")
                    (str (text "mod_panel:label.ban_reason")))
                (textarea
                    ("type" "text")
                    ("name" "reason")
                    ("id" "reason")
                    ("placeholder" "ban reason")
                    ("minlength" "2")
                    (text "{{ profile.ban_reason|remove_script_tags|safe }}")))
            (button
                (str (text "general:action.save")))))
    (div
        ("class" "card-nest w-full")
        (div
            ("class" "card small flex items-center justify-between gap-2")
            (div
                ("class" "flex items-center gap-2")
                (text "{{ icon \"blocks\" }}")
                (span
                    (text "{{ text \"mod_panel:label.permissions_level_builder\" }}")))
            (button
                ("class" "small lowered")
                ("onclick" "update_user_role(Number.parseInt(document.getElementById('role').value))")
                (text "{{ icon \"check\" }}")
                (span
                    (text "{{ text \"general:action.save\" }}"))))
        (div
            ("class" "card lowered flex flex-col gap-2")
            ("id" "permission_builder")))
    (div
        ("class" "card-nest w-full")
        (div
            ("class" "card small flex items-center justify-between gap-2")
            (div
                ("class" "flex items-center gap-2")
                (text "{{ icon \"blocks\" }}")
                (span
                    (text "{{ text \"mod_panel:label.permissions_level_builder\" }}")))
            (button
                ("class" "small lowered")
                ("onclick" "update_user_secondary_role(Number.parseInt(document.getElementById('secondary_role').value))")
                (text "{{ icon \"check\" }}")
                (span
                    (text "{{ text \"general:action.save\" }}"))))
        (div
            ("class" "card lowered flex flex-col gap-2")
            ("id" "secondary_permission_builder")))
    (script
        (text "setTimeout(async () => {
            const get_permissions_html = await trigger(
                \"ui::generate_permissions_ui\",
                [
                    {
                        // https://trisuaso.github.io/tetratto/tetratto/model/permissions/struct.FinePermission.html
                        DEFAULT: 1 << 0,
                        ADMINISTRATOR: 1 << 1,
                        MANAGE_COMMUNITIES: 1 << 2,
                        MANAGE_POSTS: 1 << 3,
                        MANAGE_POST_REPLIES: 1 << 4,
                        MANAGE_USERS: 1 << 5,
                        MANAGE_BANS: 1 << 6,
                        MANAGE_WARNINGS: 1 << 7,
                        MANAGE_NOTIFICATIONS: 1 << 8,
                        VIEW_REPORTS: 1 << 9,
                        VIEW_AUDIT_LOG: 1 << 10,
                        MANAGE_MEMBERSHIPS: 1 << 11,
                        MANAGE_REACTIONS: 1 << 12,
                        MANAGE_FOLLOWS: 1 << 13,
                        MANAGE_VERIFIED: 1 << 14,
                        MANAGE_AUDITLOG: 1 << 15,
                        MANAGE_REPORTS: 1 << 16,
                        BANNED: 1 << 17,
                        INFINITE_COMMUNITIES: 1 << 18,
                        SUPPORTER: 1 << 19,
                        MANAGE_REQUESTS: 1 << 20,
                        MANAGE_QUESTIONS: 1 << 21,
                        MANAGE_CHANNELS: 1 << 22,
                        MANAGE_MESSAGES: 1 << 23,
                        MANAGE_UPLOADS: 1 << 24,
                        MANAGE_EMOJIS: 1 << 25,
                        MANAGE_STACKS: 1 << 26,
                        STAFF_BADGE: 1 << 27,
                        MANAGE_APPS: 1 << 28,
                        MANAGE_JOURNALS: 1 << 29,
                        MANAGE_NOTES: 1 << 30,
                    },
                ],
            );

            document.getElementById(\"permission_builder\").innerHTML =
                get_permissions_html(
                    Number.parseInt(\"{{ profile.permissions }}\"),
                    \"permission_builder\",
                );
        }, 250);

        setTimeout(async () => {
            const get_permissions_html = await trigger(
                \"ui::generate_permissions_ui\",
                [
                    {
                        // https://trisuaso.github.io/tetratto/tetratto/model/permissions/struct.SecondaryPermission.html
                        DEFAULT: 1 << 0,
                        ADMINISTRATOR: 1 << 1,
                        MANAGE_DOMAINS: 1 << 2,
                        MANAGE_SERVICES: 1 << 3,
                        MANAGE_PRODUCTS: 1 << 4,
                        DEVELOPER_PASS: 1 << 5,
                    },
                    \"secondary_role\",
                    \"add_permission_to_secondary_role\",
                    \"remove_permission_to_secondary_role\",
                ],
            );

            document.getElementById(\"secondary_permission_builder\").innerHTML =
                get_permissions_html(
                    Number.parseInt(\"{{ profile.secondary_permissions }}\"),
                    \"secondary_permission_builder\",
                );
        }, 250);")))

(text "{% endblock %}")
